precision highp float;

attribute vec3 position;
attribute vec2 uv;

uniform vec4 u_mainuvtransform;
uniform mat4 worldViewProjection;
uniform mat4 world;
uniform mat4 shadow0LightMat;

varying vec3 v_position;
varying vec4 v_uv;
varying vec4 v_PositionFromLight;

void main() 
{
	gl_Position = worldViewProjection * vec4(position, 1.0);

    v_uv.xy = uv;

    v_uv.zw = uv * u_mainuvtransform.xy + u_mainuvtransform.zw;

	v_PositionFromLight = shadow0LightMat * world * vec4(position, 1.0);
}